/** Pikku esimerkki yhdenaikaisuuden aiheuttamasta kilpa-ajosta eli
 *  race conditionista. Summaus globaaliin muuttujaan vaatii useita
 *  konekielisiä käskyjä, joiden välissä voi tulla kellokeskeytys!
 *  Korjaus keskinäisesti poissulkevalla (mutual exclusion, mutex)
 *  -lukolla myöhemmässä esimerkissä.
 *
 *  HUOM: Esimerkkien lyhentämiseksi näissä ei tarkisteta,
 *  onnistuivatko operaatiot. Oikeassa ohjelmassa AINA tarkistettava
 *  esim. onnistuiko säikeen luonti vai ei, ja käsiteltävä
 *  epäonnistuminen!!
 */

#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <pthread.h>

#define N 100000000
uint64_t summa = 0;

void * saikeen_koodi(void *v) {
    int i;
    for (i = 1; i <= N; i++){
        summa++;
    }
    return NULL;
}

int main(int argc, char *argv[]) {
     int n;
     pthread_t saieA, saieB;

     pthread_create(&saieA, NULL, saikeen_koodi, NULL);
     pthread_create(&saieB, NULL, saikeen_koodi, NULL);
     
     pthread_join(saieA, NULL);
     pthread_join(saieB, NULL);

     printf("Summa on %" PRId64 " - pittäis olla %" PRId64 "\n", summa, 2*N);
     
     return 0;
}
